Portal_Proveedor/Controllers/AdministracionController.cs
using Portal_Proveedor.Models.Administracion;
using Portal_Proveedor.Models.Registro;
using System;
using System.Collections.Generic;
using System.Web.Mvc;
using System.Web.Security;

namespace Portal_Proveedor.Controllers
{
    public class AdministracionController : Controller
    {
        // GET: Administracion
        public ActionResult Index()
        {
            return View();
        }

        [Authorize(Roles = "admin")]
        public ActionResult ReporteInicioSesion()
        {
            return View();

        }

        [Authorize(Roles = "usuario")]
        public ActionResult CambiarClave()
        {
            return View();
        }

        [Authorize(Roles = "usuario")]
        //[ValidateAntiForgeryToken]
        public string CambiarLaClave(string claveVieja, string claveNueva)
        {
            string resultado = null;

            try
            {
                MembershipUser user = Membership.GetUser(User.Identity.Name);

                if (user.ChangePassword(claveVieja, claveNueva))
                {
                    resultado = "Ok";
                }
                else
                {
                    resultado = "Error";
                }
            }
            catch (Exception ex)
            {
                resultado = "Error";
            }

            return resultado;
        }

        [Authorize(Roles = "usuario")]
        public ActionResult Perfil()
        {
            AdministracionDM adm = new AdministracionDM();
            Registro proveedor = adm.ConsultarDatosDelProveedor(User.Identity.Name);
            return View(proveedor);
        }

        [Authorize(Roles = "admin")]
        public PartialViewResult InicioSesion()
        {
            RegistroDM rdm = new RegistroDM();
            List<UsuariosIngresados> lista = rdm.ListaDeUsuarios();
            return PartialView(lista);
        }

        [Authorize(Roles = "admin")]
        public PartialViewResult UsuariosBloqueados()
        {
            AdministracionDM adm = new AdministracionDM();
            List<UsuariosBloqueados> lista = adm.ReporteUsuariosBloqueados();
            return PartialView(lista);
        }

        [Authorize(Roles = "admin")]
        public PartialViewResult IntentosFallidos()
        {
            AdministracionDM adm = new AdministracionDM();
            List<IntentosFallidos> lista = adm.ReporteIntentosFallidos();
            return PartialView(lista);
        }

        public string DesbloquearUsuario(string id)
        {
            string resultado = "Usuario desbloqueado";
            if (id != null || id != "")
            {
                MembershipUser user = Membership.GetUser(id);
                if (user.IsLockedOut)
                    user.UnlockUser();
            }
            return resultado;
        }

        [HttpGet]
        [Authorize(Roles = "admin")]
        public ActionResult CambioClave()
        {
            Registro usuario = new Registro();
            return View(usuario);
        }

        [HttpPost]
        [Authorize(Roles = "admin")]
        public ActionResult CambioClave(Registro usuario)
        {
            try
            {
                MembershipUser user = Membership.GetUser(usuario.UserName);

                if (user != null)
                {
                    if (user.IsLockedOut)
                        user.UnlockUser();
                    string clave = user.ResetPassword();
                    ModelState.AddModelError("usuario", "La nueva contraseña es: " + clave);
                }
                else
                {
                    //Usuario no existe
                    ModelState.AddModelError("msjError", "El usuario indicado no existe.");
                }
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("msjError", "Ha ocurrido el siguiente error: " + ex.Message);
            }
            return View(usuario);
        }

        [HttpGet]
        [Authorize(Roles = "admin")]
        public ActionResult CambioCorreo()
        {
            Registro usuario = new Registro();
            return View(usuario);
        }

        [HttpPost]
        [Authorize(Roles = "admin")]
        public ActionResult CambioCorreo(Registro usuario)
        {



            try
            {
                MembershipUser user = Membership.GetUser(usuario.UserName);
                if (user != null)
                {
                    user.Email = usuario.correo;
                    Membership.UpdateUser(user);
                    ModelState.AddModelError("usuario", "Se ha modificado el correo exitosamente.");
                }
                else
                {
                    //Usuario no existe
                    ModelState.AddModelError("msjError", "El usuario indicado no existe.");
                }
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("msjError", "Ha ocurrido el siguiente error: " + ex.Message);
            }
            return View(usuario);
        }
    }
}

Portal_Proveedor/Controllers/OnBaseController.cs
using Portal_Proveedor.Models.Administracion;
using Portal_Proveedor.Models.Correo;
using Portal_Proveedor.Models.OnBase;
using Portal_Proveedor.Models.Registro;
using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;

namespace Portal_Proveedor.Controllers
{
    public class OnBaseController : Controller
    {
        private DocumentosDM ddm = new DocumentosDM();
        private CorreoElectronicoDM cdm = new CorreoElectronicoDM();

        // GET: OnBase
        public ActionResult Index()
        {
            return View();
        }

        #region Carga Individual de Facturas

        [Authorize(Roles = "usuario")]
        public ActionResult RegistroFacturas()
        {
            List<Documentos> lista = new List<Documentos>();

            lista = ddm.ConsultaOrdenesCompra(User.Identity.Name);

            return View(lista);
        }

        [Authorize(Roles = "usuario")]
        public ActionResult ImportarFactura(Documentos doc)
        {
            // Validar constancia de pago a cuenta
            doc.tieneConstancia = ddm.ConsultaConstanciaPagoCuenta(User.Identity.Name);
            return View(doc);
        }

        [Authorize(Roles = "usuario")]
        public ActionResult ImportaFactura(Documentos doc)
        {
            string email = Membership.GetUser().Email;
            doc.codigoProveedor = User.Identity.Name;
            long nuevoDoc = ddm.ImportarDocumentoPath(doc);

            if (nuevoDoc > 0)
            {
                ViewBag.Message = "La factura se ha almacenado correctamente.";
                cdm.EnviarCorreo(email, doc.numFiscal, 4);
            }
            else
            {
                switch (nuevoDoc)
                {
                    case -2:
                        ViewBag.Message = "El número de factura fue ingresado anteriormente, y se encuentra en revisión. Por favor verifique los datos ingresados.";
                        break;
                    case -3:
                        ViewBag.Message = "El monto de la Orden de Compra es menor del declarado en la factura. Por favor verifique los datos ingresados.";
                        break;
                    default:
                        ViewBag.Message = "No se ha almacenado la factura, inténtelo de nuevo. Si el problema persiste comuníquese con el administrador.";
                        break;
                }

            }

            return View(doc);
        }


        #endregion


        #region Carga Masiva de Facturas


        [Authorize(Roles = "usuario")]
        public ActionResult CargaMasivaFacturas()
        {
            List<Documentos> lista = new List<Documentos>();

            Documentos doc = new Documentos();

            lista = ddm.ConsultaOrdenesCompra(User.Identity.Name);
            if (lista.Count > 0) lista[0].tieneConstancia = ddm.ConsultaConstanciaPagoCuenta(User.Identity.Name);

            // lista = ddm.ConsultaDocumentos(User.Identity.Name);
            HttpContext.Session["listaPO"] = lista;
            return View(lista);
        }

        [Authorize(Roles = "usuario")]
        public ActionResult CargaDeFacturas(HttpPostedFileBase file, IEnumerable<HttpPostedFileBase> files)
        {
            List<ExcelResultado> lista = new List<ExcelResultado>();
            List<Documentos> listaPO = new List<Documentos>();

            if (HttpContext.Session["listaPO"] != null)
                listaPO = HttpContext.Session["listaPO"] as List<Documentos>;
            try
            {
                lista = ddm.CargarMasivamenteDocumentos(file, listaPO, User.Identity.Name, files);

                string email = Membership.GetUser().Email;
                cdm.EnviarCorreo(email, lista, 5);
            }
            catch (Exception ex)
            {
                ExcelResultado docs = new ExcelResultado();
                docs.consecutivo = 1;
                docs.Estado = "Ha ocurrido un error. Verifique la información ingresada en el Excel.";
                lista.Add(docs);
            }

            return View(lista);
        }

        #endregion


        #region Constancia de pago a cuenta

        [HttpGet]
        [Authorize(Roles = "usuario")]
        public ActionResult ImportarConstanciaCuenta()
        {
            AdministracionDM adm = new AdministracionDM();
            Registro proveedor = adm.ConsultarDatosDelProveedor(User.Identity.Name);
            Documentos doc = new Documentos();
            doc.codigoProveedor = User.Identity.Name;
            doc.rtn = proveedor.RTN;

            return View(doc);
        }

        [HttpPost]
        [Authorize(Roles = "usuario")]
        public ActionResult ImportarConstanciaCuenta(Documentos doc)
        {
            long nuevoDoc = ddm.ImportarDocumentoConstancia(doc);
            string email = Membership.GetUser().Email;
            if (nuevoDoc > 0)
            {
                ModelState.AddModelError("tieneConstancia", "La constancia de pago a cuenta se ha almacenado correctamente.");
                cdm.EnviarCorreo(email, doc.fechaDeVencimiento, 3);
            }
            else
            {
                ModelState.AddModelError("estado", "Ha ocurrido un error al importar el documento. Inténtelo nuevamente, si el problema persiste comuníquese con el administrador.");
            }

            return View("ImportarConstanciaCuenta", doc);
        }


        [Authorize(Roles = "usuario")]
        public string ImportaConstanciaCuenta(Documentos doc)
        {
            long nuevoDoc = ddm.ImportarDocumentoConstancia(doc);
            string resultado = "";
            if (nuevoDoc > 0)
            {
                resultado = "La constancia de pago a cuenta se ha almacenado correctamente.";
            }
            else
            {
                resultado = "Ha ocurrido un error al importar el documento. Inténtelo nuevamente, si el problema persiste comuníquese con el administrador.";
            }



            return resultado;
        }

        #endregion

        public ActionResult Prueba()
        {
            return View();
        }

        [Authorize(Roles = "usuario")]
        public ActionResult ConsultaFacturacion()
        {
            List<Documentos> lista = ddm.ConsultarDocumentosPOyFacturas(User.Identity.Name);
            return View(lista);
        }


        public string ConsultarDoc(long id)
        {
            string doc = string.Empty;

            id = 18058;

            doc = ddm.ConsultarDocumento(id, User.Identity.Name);

            return doc;
        }

        #region Estado de Cuenta


        [Authorize(Roles = "usuario")]
        public ActionResult EstadoCuenta()
        {

            List<Documentos> doc = ddm.ConsultarEstadoCuenta(User.Identity.Name);

            return View(doc);
        }

        [Authorize(Roles = "usuario")]
        public ActionResult EstadoCuentaConFechas()
        {
            return View();
        }

        public PartialViewResult EstadoDeCuenta(string id)/*DateTime fechaInicio, DateTime fechaFin)*/
        {
            DateTime fechaInicio = DateTime.Now.AddDays(-30);
            DateTime fechaFin = DateTime.Now;

            if (id == null && HttpContext.Session["ID"] != null) id = HttpContext.Session["ID"].ToString();

            if (id != null)
            {
                HttpContext.Session["ID"] = id;
                string[] lista = id.Split('?');
                fechaInicio = DateTime.Parse(lista[0]);
                fechaFin = DateTime.Parse(lista[1]).AddDays(1);
            }

            List<Documentos> doc = ddm.ConsultarEstadoCuentaConFecha(User.Identity.Name, fechaInicio, fechaFin);

            return PartialView(doc);
        }


        [Authorize(Roles = "usuario")]
        public ActionResult EstadoCuentaImpresion()
        {
            List<Documentos> doc = ddm.ConsultarEstadoCuenta(User.Identity.Name);
            if (doc.Count > 0)
            {
                MembershipUser user = Membership.GetUser(User.Identity.Name);
                doc[0].rtn = user.Comment;
            }
            return PartialView(doc);
        }

        [Authorize(Roles = "usuario")]
        public ActionResult ImprimirEstadoCuenta()
        {
            var report = new Rotativa.MVC.ActionAsPdf("EstadoCuentaImpresion");
            //{
            //    FileName = "Estado de cuenta -Portal de proveedores MQA.pdf"
            //};

            //return new Rotativa.AspNetCore.ViewAsPdf("DemoPageSizePDF")
            //{
            //    PageSize = Rotativa.AspNetCore.Options.Size.A6,
            //};

            return report;

        }

        [Authorize(Roles = "usuario")]
        public ActionResult EstadoCuentaImpresionConFechas()
        {
            string id = null;
            DateTime fechaInicio = DateTime.Now.AddDays(-30);
            DateTime fechaFin = DateTime.Now;

            if (HttpContext.Session["ID"] != null)
            {
                id = HttpContext.Session["ID"].ToString();
                string[] lista = id.Split('?');
                fechaInicio = DateTime.Parse(lista[0]);
                fechaFin = DateTime.Parse(lista[1]).AddDays(1);
                ViewBag.FechaFin = fechaFin.AddDays(-1).ToShortDateString();
            }
            else
            {
                ViewBag.FechaFin = fechaFin.ToShortDateString();
            }

            ViewBag.FechaInicio = fechaInicio.ToShortDateString();


            List<Documentos> doc = ddm.ConsultarEstadoCuentaConFecha(User.Identity.Name, fechaInicio, fechaFin);
            if (doc.Count > 0)
            {
                MembershipUser user = Membership.GetUser(User.Identity.Name);
                doc[0].rtn = user.Comment;
            }
            return PartialView(doc);
        }

        [Authorize(Roles = "usuario")]
        public ActionResult ImprimirEstadoCuentaConFechas()
        {

Portal_Proveedor/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<!--[if IE 7 ]>		 <html class="no-js ie ie7 lte7 lte8 lte9" lang="en-US"> <![endif]-->
<!--[if IE 8 ]>		 <html class="no-js ie ie8 lte8 lte9" lang="en-US"> <![endif]-->
<!--[if IE 9 ]>		 <html class="no-js ie ie9 lte9>" lang="en-US"> <![endif]-->
<!--[if (gt IE 9)|!(IE)]><!-->
<html class="no-js" lang="en-US">
<!--<![endif]-->
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>@ViewBag.Title - Portal de proveedores</title>
    @*@Styles.Render("~/Content/css")
        @Scripts.Render("~/bundles/modernizr")
        @Scripts.Render("~/bundles/bootstrap")*@


    <link href="@Url.Content("~/Content/Site.css")" rel="stylesheet" />
    <link href="@Url.Content("~/Content/bootstrap.css")" rel="stylesheet" />
    <script src="@Url.Content("~/Scripts/modernizr-2.6.2.js")"></script>



    <link href="@Url.Content("~/Content/jquery-ui/jquery-ui.min.css")" rel="stylesheet" />

    <script src="@Url.Content("~/Content/jquery-ui/external/jquery/jquery.js")"></script>
    <script src="@Url.Content("~/Content/jquery-ui/jquery-ui.js")"></script>

    <script src="@Url.Content("~/Scripts/bootstrap.js")"></script>
    <script src="@Url.Content("~/Scripts/respond.js")"></script>

    <script src="@Url.Content("~/Content/noty/jquery.noty.js")"></script>
    <script src="@Url.Content("~/Content/noty/themes/relax.js")"></script>
    <script src="@Url.Content("~/Content/noty/layouts/topCenter.js")"></script>
    <script src="@Url.Content("~/Content/noty/layouts/center.js")"></script>

    <script>
        function Alerta(tipo, mensaje, wh) {
            noty({
                layout: wh,
                text: mensaje,
                type: tipo,
                theme: 'relax', // or 'relax'
                dismissQueue: true,
                timeout: false, // delay for closing event. Set false for sticky notifications
                force: false, // adds notification to the beginning of queue when set to true
                timeout: 3500,
                modal: false,
                maxVisible: 7, // you can set max visible notification for dismissQueue true option,
                killer: false, // for close all notifications before show
                closeWith: ['click'], // ['click', 'button', 'hover', 'backdrop'] // backdrop click will close all notifications
                buttons: false // an array of buttons,

            });
        }
    </script>

</head>
<body>
    <div class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                @*@Html.ActionLink("Portal", "Index", "Home", new { area = "" }, new { @class = "navbar-brand" })*@
                @Html.Label("Portal", new { @class = "navbar-brand" })
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">

                    @if (User.Identity.IsAuthenticated)
                    {
                        if (!User.IsInRole("admin"))
                        {
                            <li> @Html.ActionLink("Const. Pago Cuenta", "ImportarConstanciaCuenta", "OnBase") </li>
                            <li> @Html.ActionLink("Registro Facturas", "RegistroFacturas", "OnBase") </li>
                            <li> @Html.ActionLink("Carga Masiva Facturas", "CargaMasivaFacturas", "OnBase") </li>
                            <li> @Html.ActionLink("Facturación", "ConsultaFacturacion", "OnBase") </li>
                            <li>@Html.ActionLink("Estado Cuenta", "EstadoCuenta", "OnBase")</li>
                        }
                        if (User.IsInRole("admin"))
                        {
                            <li>@Html.ActionLink("Reportes", "ReporteInicioSesion", "Administracion")</li>
                            <li>@Html.ActionLink("Cambio Clave", "CambioClave", "Administracion")</li>
                            <li>@Html.ActionLink("Cambio Correo", "CambioCorreo", "Administracion")</li>
                        }
                    }
                    @*<li>@Html.ActionLink("About", "About", "Home")</li>
        <li>@Html.ActionLink("Contact", "Contact", "Home")</li>*@
                </ul>
                @Html.Partial("_LoginPartial")
            </div>
        </div>
    </div>
    <div class="container body-content">
        <div class="se-pre-con"></div>
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; @DateTime.Now.Year - Portal de proveedores @*CENOSA*@</p>
        </footer>
    </div>

    @*@Scripts.Render("~/bundles/jquery")
        @RenderSection("scripts", required: false)*@
</body>
</html>

<style>
/* Paste this css to your style sheet file or under head tag */
/* This only works with JavaScript, if it's not present, don't show loader */

    .no-js #loader {
        display: none;
    }

    .js #loader {
        display: block;
        position: absolute;
        left: 100px;
        top: 0;
    }

    .se-pre-con {
        position: fixed;
        left: 0px;
        top: 0px;
        width: 100%;
        height: 100%;
        z-index: 9999;
        background: url(@Url.Content("~/Content/images/loader-64x/Preloader_2.gif")) center no-repeat #fff;
    }
</style>



<script type="text/javascript">
    $(window).load(function () {
        // Animate loader off screen
        $(".se-pre-con").fadeOut("slow");
    });
    $(window).on('beforeunload', function () {
        $(".se-pre-con").fadeIn(50);
    });
</script>